/*
 * Created on 08.09.2004
 *
 */
package org.tigris.subversion.javahl.forpacker;

import org.tigris.subversion.javahl.SVNClientForPacker;

/**
 * This class exists for the sole purpose of providing the functionality of the
 * packer extended SVNClient class under this name.
 * 
 * Subversions build mechanism lets javah generate header files for all classes
 * located in the org.tigris.subversion.javahl package.
 * 
 * It puts all class files into the svn-javahl.jar package which implement
 * classes located in the org.tigris.subversion.javahl package or packages
 * contained therein.
 * 
 * We want the actual class name to be SVNClient but that class already exists
 * in the org.tigris.subversion.javahl package.
 * 
 * So we put a class of that name into the forpacker sub package. That is this
 * class. Unfortunately subversions build mechanism doesn't let javah generate
 * header files for classes located in the forpacker sub package.
 * 
 * To work around this the class containing the native method declarations for
 * the additional functionality is located in the org.tigris.subversion.javahl
 * package but with the name SVNClientForPacker.
 * 
 * @author dhoffmann
 */
public class SVNClient extends SVNClientForPacker {

    public SVNClient() {
        super();
    }

}