/*
 * Created on 07.09.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.tigris.subversion.javahl.forpacker;

import org.tigris.subversion.javahl.ClientException;
import org.tigris.subversion.javahl.PropertyData;
import org.tigris.subversion.javahl.Revision;

/**
 * @author dhoffmann
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public interface SVNClientInterface extends
        org.tigris.subversion.javahl.SVNClientInterface {

    /**
     * Renames a file.
     * 
     * @param srcPath
     *            source path or url
     * @param destPath
     *            destination path or url
     * @param message
     *            commit message if destPath is an url
     * @param revision
     *            source revision
     * @param force
     *            even with local modifications.
     * @exception ClientException
     */
    void rename(String srcPath, String destPath, String message,
            Revision revision, boolean force) throws ClientException;

    /**
     * Copies a local file into the repository without needing a local working
     * copy.
     * 
     * @param srcPath
     *            source path
     * @param destPath
     *            destination url
     * @param message
     *            commit message
     * @return the number of the newly created revision
     * @throws ClientException
     */
    long put(String srcPath, String destPath, String message)
            throws ClientException;

    /**
     * Copies a local file into the repository without needing a local working
     * copy.
     * 
     * @param srcPath
     *            source path
     * @param destPath
     *            destination url
     * @param message
     *            commit message
     * @param forbidOverwrite
     *            if <code>true</code> and <code>destPath</code> already
     *            exists an exception will be raised
     * @return the number of the newly created revision
     * @throws ClientException
     */
    long put(String srcPath, String destPath, boolean forbidOverwrite,
            String message) throws ClientException;

    /**
     * Set the value of a property. Attach property to file if this didn't
     * happen in the past.
     * 
     * @param url
     *            the URL of the file or directory holding the property
     * @param name
     *            the name of the property
     * @param value
     *            the new value of the property
     * @param message
     *            the commit message
     * @return @throws
     *         ClientException
     */
    long propertySet(String url, String name, String value, String message)
            throws ClientException;

    /**
     * Retrieves the properties of an item
     * 
     * @param path
     *            the path of the item
     * @param revision
     *            the revision of the item
     * @return array of property objects
     */
    PropertyData[] properties(String path, Revision revision) throws ClientException;

    /**
     * Set the value of a property. Attach property to file if this didn't
     * happen in the past.
     * 
     * @param url
     *            the URL of the file or directory holding the property
     * @param name
     *            the name of the property
     * @param value
     *            the new value of the property
     * @param message
     *            the commit message
     * @return @throws
     *         ClientException
     */
    long propertyRemove(String url, String name, String message)
            throws ClientException;

    /**
     * Resolve the HEAD revision into its numerical equivalent.
     * 
     * @param path
     *            some path pointing into the repository
     * @return the HEAD revision as Revision.Number object
     * @throws ClientException
     */
    Revision headRevision(String path) throws ClientException;

    /**
     * Return the repositories root url.
     * 
     * @param path
     *            some path pointing into the repository
     * @return the repositories root url
     * @throws ClientException
     */
    String repositoryUrl(String path) throws ClientException;

    /**
     * Return the kind of the node as a NodeKind object
     * 
     * @param path
     * @param revision
     * @return @throws
     *         ClientException
     */
    int nodeKind(String path, Revision revision) throws ClientException;

}